package com.ruoyi.web.controller.aliexpress;

import com.global.iop.api.IopClient;
import com.global.iop.api.IopClientImpl;
import com.global.iop.api.IopRequest;
import com.global.iop.api.IopResponse;
import com.global.iop.domain.Protocol;
import com.global.iop.util.ApiException;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.web.controller.aliexpress.dto.member.MemberDsOrderDataSaveDTO;
import com.ruoyi.web.controller.aliexpress.dto.member.MemberOauthAuthorizeDTO;
import com.ruoyi.web.controller.aliexpress.dto.member.MemberQueryAccountLevelDTO;
import com.ruoyi.web.controller.aliexpress.dto.member.MemberUicQueryTbNickDTO;
import com.ruoyi.web.core.config.AliexpressAuthClientConfig;
import com.ruoyi.web.enumerate.AliexpressMemberEnu;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @author ldj
 * @date 2024/2/29 15:17
 * @Description: ...
 * @Version 1.0
 */
@RestController
@Api("对接速卖通 类目")
@RequestMapping("/aliexpress/member")
public class AliexpressMemberController {

    @Resource
    private AliexpressAuthClientConfig AliexpressAuthClientConfig;

    //查询淘宝的nickName
    //描述：通过AE的loginId查询淘宝的nickName
    /*
IopClient client = new IopClient(url, appkey, appSecret);
IopRequest request = new IopRequest();
request.setApiName("aliexpress.member.redefining.uicquerytbnick");
request.addApiParameter("login_id", "cn1519431219gong");
IopResponse response = client.execute(request, Protocol.TOP);
System.out.println(response.getBody());
Thread.sleep(10);
     */

    /**
     * 查询淘宝的nickName
     */
    @Log(title = "查询淘宝的nickName", businessType = BusinessType.SELECT)
    @ApiOperation("查询淘宝的nickName")
    @PostMapping("/uicQueryTbNick")
    public String uicQueryTbNick(@RequestBody MemberUicQueryTbNickDTO reqDto) throws ApiException {
        IopClient client = new IopClientImpl(AliexpressAuthClientConfig.getUrl(), AliexpressAuthClientConfig.getAppKey(), AliexpressAuthClientConfig.getAppSecret());
        IopRequest request = new IopRequest();
        request.setApiName(AliexpressMemberEnu.UIC_QUERY_TB_NICK.getApiName());
        request.addApiParameter("login_id", reqDto.getLoginId());
        IopResponse response = client.execute(request, Protocol.TOP);
        return response.getGopResponseBody();
    }

    //收集下单的用户和订单金额等信息
    //描述：收集dropshipper导购站点下单的用户和订单金额等信息
    /*
IopClient client = new IopClient(url, appkey, appSecret);
IopRequest request = new IopRequest();
request.setApiName("aliexpress.member.ds.orderdata.save");
request.addApiParameter("dser_collect_data", "{\"ae_product_id\":\"1334345\",\"ae_sku_info\":\"200000182:193;200007763:201336100\",\"product_url\":\"https://www.yousite.com/item/32862631421.html\",\"order_amount\":\"35.33\",\"paytime\":\"20191122:150606\",\"ae_orderid\":\"1334345\",\"product_amount\":\"35.33\"}");
IopResponse response = client.execute(request, accessToken, Protocol.TOP);
System.out.println(response.getBody());
Thread.sleep(10);
     */

    /**
     * 收集下单的用户和订单金额等信息
     */
    @Log(title = "收集下单的用户和订单金额等信息", businessType = BusinessType.SELECT)
    @ApiOperation("收集下单的用户和订单金额等信息")
    @PostMapping("/dsOrderDataSave")
    public String dsOrderDataSave(@RequestBody MemberDsOrderDataSaveDTO reqDto) throws ApiException {
        IopClient client = new IopClientImpl(AliexpressAuthClientConfig.getUrl(), AliexpressAuthClientConfig.getAppKey(), AliexpressAuthClientConfig.getAppSecret());
        IopRequest request = new IopRequest();
        request.setApiName(AliexpressMemberEnu.DS_ORDER_DATA_SAVE.getApiName());
        request.addApiParameter("dser_collect_data", reqDto.getDserCollectData());
        IopResponse response = client.execute(request, reqDto.getAccessToken(), Protocol.TOP);
        return response.getGopResponseBody();
    }

    //oauth授权
    //描述：该开放接口使用OK的authCode 映射到AE账号上进行Top平台的授权操作
    /*
IopClient client = new IopClient(url, appkey, appSecret);
IopRequest request = new IopRequest();
request.setApiName("aliexpress.member.oauth.authorize");
request.addApiParameter("response_type", "code");
request.addApiParameter("sns_authorization_code", "afjaodfjaojdfoajdfioa");
request.addApiParameter("sns_type", "ok");
request.addApiParameter("auto_register", "true");
IopResponse response = client.execute(request, Protocol.TOP);
System.out.println(response.getBody());
Thread.sleep(10);
     */

    /**
     * oauth授权
     */
    @Log(title = "oauth授权", businessType = BusinessType.SELECT)
    @ApiOperation("oauth授权")
    @PostMapping("/oauthAuthorize")
    public String oauthAuthorize(@RequestBody MemberOauthAuthorizeDTO reqDto) throws ApiException {
        IopClient client = new IopClientImpl(AliexpressAuthClientConfig.getUrl(), AliexpressAuthClientConfig.getAppKey(), AliexpressAuthClientConfig.getAppSecret());
        IopRequest request = new IopRequest();
        request.setApiName(AliexpressMemberEnu.OAUTH_AUTHORIZE.getApiName());
        request.addApiParameter("response_type", reqDto.getResponseType());
        request.addApiParameter("sns_authorization_code", reqDto.getSnsAuthorizationCode());
        request.addApiParameter("sns_type", reqDto.getSnsType());
        request.addApiParameter("auto_register", reqDto.getAutoRegister());
        IopResponse response = client.execute(request, Protocol.TOP);
        return response.getGopResponseBody();
    }
    //查询会员账户等级
    //描述：根据买家登录ID查询会员等级。平台对买家层级的标识，以A0-A4五个等级进行标注，数字越高，等级越高，买家越活跃，购买力越强,卖家朋友可根据买家分层更好的服务于买家。
    /*
IopClient client = new IopClient(url, appkey, appSecret);
IopRequest request = new IopRequest();
request.setApiName("aliexpress.member.redefining.queryaccountlevel");
request.addApiParameter("login_id", "jordenmail");
IopResponse response = client.execute(request, accessToken, Protocol.TOP);
System.out.println(response.getBody());
Thread.sleep(10);
     */

    /**
     * 查询会员账户等级
     */
    @Log(title = "查询会员账户等级", businessType = BusinessType.SELECT)
    @ApiOperation("查询会员账户等级")
    @PostMapping("/queryAccountLevel")
    public String queryAccountLevel(@RequestBody MemberQueryAccountLevelDTO reqDto) throws ApiException {
        IopClient client = new IopClientImpl(AliexpressAuthClientConfig.getUrl(), AliexpressAuthClientConfig.getAppKey(), AliexpressAuthClientConfig.getAppSecret());
        IopRequest request = new IopRequest();
        request.setApiName(AliexpressMemberEnu.QUERY_ACCOUNT_LEVEL.getApiName());
        request.addApiParameter("login_id", reqDto.getLoginId());
        IopResponse response = client.execute(request, reqDto.getAccessToken(), Protocol.TOP);
        return response.getGopResponseBody();
    }
}
