package com.ruoyi.ap;

/**
 * @author ldj
 * @date 2024/2/27 10:30
 * @Description: ...
 * @Version 1.0
 */
public class ProducerConsumerTest {
    public static void main(String[] args) throws InterruptedException {
        // 创建生产者消费者模型对象
        ProducerConsumerModel model = new ProducerConsumerModel();

        // 创建生产者线程
        Thread producer = new Thread(() -> {
            try {
                for (int i = 0; i < 100; i++) {
                    model.produce(i);
                    // 模拟生产时间
                    Thread.sleep(100);
                }
            } catch (InterruptedException e) {
                Thread.currentThread().interrupt();
            }
        });

        // 创建消费者线程
        Thread consumer = new Thread(() -> {
            try {
                while (true) {
                    model.consume();
                    // 模拟消费时间
                    Thread.sleep(150);
                }
            } catch (InterruptedException e) {
                Thread.currentThread().interrupt();
            }
        });

        // 启动生产者和消费者线程
        producer.start();
        consumer.start();

        // 主线程等待生产者和消费者线程结束
        producer.join();
        consumer.join();
    }
}
